"use strict";
exports.Stack = {
    create: createStack
};
function createStack() {
    var elements = [];
    return {
        push: function (element) {
            elements.push(element);
        },
        pop: function () {
            return elements.pop();
        },
        peek: function () {
            return elements[elements.length - 1];
        },
        get isEmpty() {
            return elements.length === 0;
        },
        enumerateElements: function () {
            return elements.slice(0).reverse();
        },
        find: function (predicate) {
            for (var i = elements.length - 1; i >= 0; i--) {
                var element = elements[i];
                if (predicate(element)) {
                    return element;
                }
            }
            return void 0;
        }
    };
}
