"use strict";
var flow_1 = require("../flow");
function exportAsObject(flowProgram) {
    var program = {
        flowGraph: flattenFlowGraph(flowProgram.flowGraph)
    };
    var functions = flowProgram.functions.map(function (fun) { return ({
        id: fun.id,
        name: fun.name,
        flowGraph: flattenFlowGraph(fun.flowGraph)
    }); });
    return { program: program, functions: functions };
}
exports.exportAsObject = exportAsObject;
function flattenFlowGraph(flowGraph) {
    var nodes = flowGraph.nodes.map(function (node) { return ({
        id: node.id,
        type: flow_1.NodeType[node.type]
    }); });
    var edges = flowGraph.edges.map(function (edge) { return ({
        from: edge.source.id,
        to: edge.target.id,
        type: flow_1.EdgeType[edge.type],
        label: edge.label,
        data: edge.data
    }); });
    return { nodes: nodes, edges: edges };
}
