"use strict";
var constantConditionalEdgeRewriting_1 = require("./constantConditionalEdgeRewriting");
var nodeAndEdgeCollecting_1 = require("./nodeAndEdgeCollecting");
var transitNodeRemoval_1 = require("./transitNodeRemoval");
var unreachableNodeRemoval_1 = require("./unreachableNodeRemoval");
function runOptimizationPasses(graphs, options) {
    for (var _i = 0, graphs_1 = graphs; _i < graphs_1.length; _i++) {
        var graph = graphs_1[_i];
        if (options.passes.rewriteConstantConditionalEdges) {
            constantConditionalEdgeRewriting_1.rewriteConstantConditionalEdges(graph);
        }
        unreachableNodeRemoval_1.removeUnreachableNodes(graph);
        if (options.passes.removeTransitNodes) {
            transitNodeRemoval_1.removeTransitNodes(graph);
        }
        nodeAndEdgeCollecting_1.collectNodesAndEdges(graph);
    }
}
exports.runOptimizationPasses = runOptimizationPasses;
