"use strict";
var numericMap_1 = require("../../collections/numericMap");
function collectNodesAndEdges(graph) {
    graph.nodes = collectNodes(graph.entry);
    graph.edges = collectEdges(graph.nodes);
}
exports.collectNodesAndEdges = collectNodesAndEdges;
function collectNodes(graphEntry) {
    var nodes = numericMap_1.NumericMap.create();
    walkGraphAndCollectNodes(graphEntry, nodes);
    return nodes.values();
}
function walkGraphAndCollectNodes(currentNode, nodes) {
    if (nodes.containsKey(currentNode.id)) {
        return;
    }
    nodes.set(currentNode.id, currentNode);
    for (var _i = 0, _a = currentNode.outgoingEdges; _i < _a.length; _i++) {
        var outgoingEdge = _a[_i];
        walkGraphAndCollectNodes(outgoingEdge.target, nodes);
    }
}
function collectEdges(nodes) {
    var edges = [];
    for (var _i = 0, nodes_1 = nodes; _i < nodes_1.length; _i++) {
        var node = nodes_1[_i];
        edges.push.apply(edges, node.outgoingEdges);
    }
    return edges;
}
